



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>android ------- 开发者的 RxJava 详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">android ------- 开发者的 RxJava 详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-15 15:55:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在正文开始之前的最后，放上&nbsp;<code>GitHub</code>&nbsp;链接和引入依赖的&nbsp;<code>gradle</code>&nbsp;代码： Github：&nbsp;<br />https://github.com/ReactiveX/RxJava&nbsp;<br />https://github.com/ReactiveX/RxAndroid&nbsp;<br />引入依赖：</p>
<div>
<pre class="prettyprint linenums">compile 'io.reactivex:rxjava:1.0.14'<br />
compile 'io.reactivex:rxandroid:1.0.1' </pre>
</div>
<p>（版本号是文章发布时的最新稳定版）</p>
<p>转载原文地址：<a href="https://gank.io/post/560e15be2dca930e00da1083" rel="external nofollow noreferrer">https://gank.io/post/560e15be2dca930e00da1083</a></p>
<p>RxJava 文档</p>
<p>链接：https://pan.baidu.com/s/1T6wrE60lBj727zeSQZ5uEw 密码：nzm1</p>
<p>目录：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1041439/201811/1041439-20181120184749533-1228192539.png" /></p>
<h3>RxJava 到底是什么</h3>
<p>一个词：<strong>异步</strong>。</p>
<p>RxJava 在 GitHub 主页上的自我介绍是 "a library for composing asynchronous and event-based programs using observable sequences for the Java VM"（一个在 Java VM 上使用可观测的序列来组成异步的、基于事件的程序的库）。这就是 RxJava ，概括得非常精准。</p>
<p>然而，对于初学者来说，这太难看懂了。因为它是一个『总结』，而初学者更需要一个『引言』。</p>
<p>其实， RxJava 的本质可以压缩为异步这一个词。说到根上，它就是一个实现异步操作的库，而别的定语都是基于这之上的。</p>
<h3>RxJava 好在哪</h3>
<p>换句话说，『同样是做异步，为什么人们用它，而不用现成的 AsyncTask / Handler / XXX / ... ？』</p>
<p>一个词：<strong>简洁</strong>。</p>
<p>异步操作很关键的一点是程序的简洁性，因为在调度过程比较复杂的情况下，异步代码经常会既难写也难被读懂。 Android 创造的AsyncTask&nbsp;和Handler&nbsp;，其实都是为了让异步代码更加简洁。RxJava 的优势也是简洁，但它的简洁的与众不同之处在于，随着程序逻辑变得越来越复杂，它依然能够保持简洁。</p>
<p><img referrerpolicy="no-referrer"src="http://www.jcodecraeer.com/uploads/20151012/1444623684122356.png" /></p>
<p>假设有这样一个需求：界面上有一个自定义的视图&nbsp;imageCollectorView&nbsp;，它的作用是显示多张图片，并能使用&nbsp;addImage(Bitmap)&nbsp;方法来任意增加显示的图片。现在需要程序将一个给出的目录数组&nbsp;File[] folders&nbsp;中每个目录下的 png 图片都加载出来并显示在imageCollectorView&nbsp;中。需要注意的是，由于读取图片的这一过程较为耗时，需要放在后台执行，而图片的显示则必须在 UI 线程执行。常用的实现方式有多种，我这里贴出其中一种：</p>
<div>
<pre class="prettyprint linenums">new Thread() {<br />
    @Override<br />
    public void run() {<br />
        super.run();<br />
        for (File folder : folders) {<br />
            File[] files = folder.listFiles();<br />
            for (File file : files) {<br />
                if (file.getName().endsWith(".png")) {<br />
                    final Bitmap bitmap = getBitmapFromFile(file);<br />
                    getActivity().runOnUiThread(new Runnable() {<br />
                        @Override<br />
                        public void run() {<br />
                            imageCollectorView.addImage(bitmap);<br />
                        }<br />
                    });<br />
                }<br />
            }<br />
        }<br />
    }<br />
}.start();</pre>
</div>
<p>而如果使用 RxJava ，实现方式是这样的：</p>
<div>
<pre class="prettyprint linenums">Observable.from(folders)<br />
    .flatMap(new Func1&lt;File, Observable&lt;File&gt;&gt;() {<br />
        @Override<br />
        public Observable&lt;File&gt; call(File file) {<br />
            return Observable.from(file.listFiles());<br />
        }<br />
    })<br />
    .filter(new Func1&lt;File, Boolean&gt;() {<br />
        @Override<br />
        public Boolean call(File file) {<br />
            return file.getName().endsWith(".png");<br />
        }<br />
    })<br />
    .map(new Func1&lt;File, Bitmap&gt;() {<br />
        @Override<br />
        public Bitmap call(File file) {<br />
            return getBitmapFromFile(file);<br />
        }<br />
    })<br />
    .subscribeOn(Schedulers.io())<br />
    .observeOn(AndroidSchedulers.mainThread())<br />
    .subscribe(new Action1&lt;Bitmap&gt;() {<br />
        @Override<br />
        public void call(Bitmap bitmap) {<br />
            imageCollectorView.addImage(bitmap);<br />
        }<br />
    });</pre>
</div>
<p>那位说话了：『你这代码明明变多了啊！简洁个毛啊！』大兄弟你消消气，我说的是逻辑的简洁，不是单纯的代码量少（逻辑简洁才是提升读写代码速度的必杀技对不？）。观察一下你会发现， RxJava 的这个实现，是一条从上到下的链式调用，没有任何嵌套，这在逻辑的简洁性上是具有优势的。当需求变得复杂时，这种优势将更加明显（试想如果还要求只选取前 10 张图片，常规方式要怎么办？如果有更多这样那样的要求呢？再试想，在这一大堆需求实现完两个月之后需要改功能，当你翻回这里看到自己当初写下的那一片迷之缩进，你能保证自己将迅速看懂，而不是对着代码重新捋一遍思路？）。</p>
<p>另外，如果你的 IDE 是 Android Studio ，其实每次打开某个 Java 文件的时候，你会看到被自动 Lambda 化的预览，这将让你更加清晰地看到程序逻辑：</p>
<div>
<pre class="prettyprint linenums">Observable.from(folders)<br />
    .flatMap((Func1) (folder) -&gt; { Observable.from(file.listFiles()) })<br />
    .filter((Func1) (file) -&gt; { file.getName().endsWith(".png") })<br />
    .map((Func1) (file) -&gt; { getBitmapFromFile(file) })<br />
    .subscribeOn(Schedulers.io())<br />
    .observeOn(AndroidSchedulers.mainThread())<br />
    .subscribe((Action1) (bitmap) -&gt; { imageCollectorView.addImage(bitmap) });</pre>
</div>
<blockquote><p>如果你习惯使用 Retrolambda ，你也可以直接把代码写成上面这种简洁的形式。而如果你看到这里还不知道什么是 Retrolambda ，我不建议你现在就去学习它。原因有两点：1. Lambda 是把双刃剑，它让你的代码简洁的同时，降低了代码的可读性，因此同时学习 RxJava 和 Retrolambda 可能会让你忽略 RxJava 的一些技术细节；2. Retrolambda 是 Java 6/7 对 Lambda 表达式的非官方兼容方案，它的向后兼容性和稳定性是无法保障的，因此对于企业项目，使用 Retrolambda 是有风险的。所以，与很多 RxJava 的推广者不同，我并不推荐在学习 RxJava 的同时一起学习 Retrolambda。事实上，我个人虽然很欣赏 Retrolambda，但我从来不用它。</p></blockquote>
<p>在Flipboard 的 Android 代码中，有一段逻辑非常复杂，包含了多次内存操作、本地文件操作和网络操作，对象分分合合，线程间相互配合相互等待，一会儿排成人字，一会儿排成一字。如果使用常规的方法来实现，肯定是要写得欲仙欲死，然而在使用 RxJava 的情况下，依然只是一条链式调用就完成了。它很长，但很清晰。</p>
<p>所以， RxJava 好在哪？就好在简洁，好在那把什么复杂逻辑都能穿成一条线的简洁。</p>
<h3>API 介绍和原理简析</h3>
<p>这个我就做不到一个词说明了&hellip;&hellip;因为这一节的主要内容就是一步步地说明 RxJava 到底怎样做到了异步，怎样做到了简洁。</p>
<h4>1. 概念：扩展的观察者模式</h4>
<p>RxJava 的异步实现，是通过一种扩展的观察者模式来实现的。</p>
<h5>观察者模式</h5>
<p>先简述一下观察者模式，已经熟悉的可以跳过这一段。</p>
<p>观察者模式面向的需求是：A 对象（观察者）对 B 对象（被观察者）的某种变化高度敏感，需要在 B 变化的一瞬间做出反应。举个例子，新闻里喜闻乐见的警察抓小偷，警察需要在小偷伸手作案的时候实施抓捕。在这个例子里，警察是观察者，小偷是被观察者，警察需要时刻盯着小偷的一举一动，才能保证不会漏过任何瞬间。程序的观察者模式和这种真正的『观察』略有不同，观察者不需要时刻盯着被观察者（例如 A 不需要每过 2ms 就检查一次 B 的状态），而是采用<strong>注册</strong>(Register)<strong>或者称为</strong>订阅<strong>(Subscribe)</strong>的方式，告诉被观察者：我需要你的某某状态，你要在它变化的时候通知我。 Android 开发中一个比较典型的例子是点击监听器&nbsp;<code>OnClickListener</code>&nbsp;。对设置&nbsp;<code>OnClickListener</code>&nbsp;来说，&nbsp;<code>View</code>&nbsp;是被观察者，&nbsp;<code>OnClickListener</code>&nbsp;是观察者，二者通过&nbsp;<code>setOnClickListener()</code>&nbsp;方法达成订阅关系。订阅之后用户点击按钮的瞬间，Android Framework 就会将点击事件发送给已经注册的&nbsp;<code>OnClickListener</code>&nbsp;。采取这样被动的观察方式，既省去了反复检索状态的资源消耗，也能够得到最高的反馈速度。当然，这也得益于我们可以随意定制自己程序中的观察者和被观察者，而警察叔叔明显无法要求小偷『你在作案的时候务必通知我』。</p>
<p>OnClickListener 的模式大致如下图：</p>
<p><img referrerpolicy="no-referrer"src="http://ww4.sinaimg.cn/mw1024/52eb2279jw1f2rx42h1wgj20fz03rglt.jpg" data-src="http://ww4.sinaimg.cn/mw1024/52eb2279jw1f2rx42h1wgj20fz03rglt.jpg" /></p>
<p>如图所示，通过&nbsp;<code>setOnClickListener()</code>&nbsp;方法，<code>Button</code>&nbsp;持有&nbsp;<code>OnClickListener</code>&nbsp;的引用（这一过程没有在图上画出）；当用户点击时，<code>Button</code>&nbsp;自动调用&nbsp;<code>OnClickListener</code>&nbsp;的&nbsp;<code>onClick()</code>&nbsp;方法。另外，如果把这张图中的概念抽象出来（<code>Button</code>&nbsp;-&gt; 被观察者、<code>OnClickListener</code>&nbsp;-&gt; 观察者、<code>setOnClickListener()</code>&nbsp;-&gt; 订阅，<code>onClick()</code>&nbsp;-&gt; 事件），就由专用的观察者模式（例如只用于监听控件点击）转变成了通用的观察者模式。如下图：</p>
<p><img referrerpolicy="no-referrer"src="http://ww3.sinaimg.cn/mw1024/52eb2279jw1f2rx4446ldj20ga03p74h.jpg" data-src="http://ww3.sinaimg.cn/mw1024/52eb2279jw1f2rx4446ldj20ga03p74h.jpg" /></p>
<p>而 RxJava 作为一个工具库，使用的就是通用形式的观察者模式。</p>
<h5>RxJava 的观察者模式</h5>
<p>RxJava 有四个基本概念：<code>Observable</code>&nbsp;(可观察者，即被观察者)、&nbsp;<code>Observer</code>&nbsp;(观察者)、&nbsp;<code>subscribe</code>&nbsp;(订阅)、事件。<code>Observable</code>&nbsp;和&nbsp;<code>Observer</code>&nbsp;通过&nbsp;<code>subscribe()</code>&nbsp;方法实现订阅关系，从而&nbsp;<code>Observable</code>&nbsp;可以在需要的时候发出事件来通知&nbsp;<code>Observer</code>。</p>
<p>与传统观察者模式不同， RxJava 的事件回调方法除了普通事件&nbsp;<code>onNext()</code>&nbsp;（相当于&nbsp;<code>onClick()</code>&nbsp;/&nbsp;<code>onEvent()</code>）之外，还定义了两个特殊的事件：<code>onCompleted()</code>&nbsp;和&nbsp;<code>onError()</code>。</p>
<ul><li><code>onCompleted()</code>: 事件队列完结。RxJava 不仅把每个事件单独处理，还会把它们看做一个队列。RxJava 规定，当不会再有新的&nbsp;<code>onNext()</code>&nbsp;发出时，需要触发&nbsp;<code>onCompleted()</code>&nbsp;方法作为标志。</li>
<li><code>onError()</code>: 事件队列异常。在事件处理过程中出异常时，<code>onError()</code>&nbsp;会被触发，同时队列自动终止，不允许再有事件发出。</li>
<li>在一个正确运行的事件序列中,&nbsp;<code>onCompleted()</code>&nbsp;和&nbsp;<code>onError()</code>&nbsp;有且只有一个，并且是事件序列中的最后一个。需要注意的是，<code>onCompleted()</code>&nbsp;和&nbsp;<code>onError()</code>&nbsp;二者也是互斥的，即在队列中调用了其中一个，就不应该再调用另一个。</li></ul>
<p>RxJava 的观察者模式大致如下图：</p>
<p><img referrerpolicy="no-referrer"src="http://ww3.sinaimg.cn/mw1024/52eb2279jw1f2rx46dspqj20gn04qaad.jpg" data-src="http://ww3.sinaimg.cn/mw1024/52eb2279jw1f2rx46dspqj20gn04qaad.jpg" /></p>
<h4>2. 基本实现</h4>
<p>基于以上的概念， RxJava 的基本实现主要有三点：</p>
<h5>1) 创建 Observer</h5>
<p>Observer 即观察者，它决定事件触发的时候将有怎样的行为。 RxJava 中的&nbsp;<code>Observer</code>&nbsp;接口的实现方式：</p>
<div>
<pre class="prettyprint linenums">Observer&lt;String&gt; observer = new Observer&lt;String&gt;() {<br />
    @Override<br />
    public void onNext(String s) {<br />
        Log.d(tag, "Item: " + s);<br />
    }

    @Override<br />
    public void onCompleted() {<br />
        Log.d(tag, "Completed!");<br />
    }

    @Override<br />
    public void onError(Throwable e) {<br />
        Log.d(tag, "Error!");<br />
    }<br />
};</pre>
</div>
<p>除了&nbsp;<code>Observer</code>&nbsp;接口之外，RxJava 还内置了一个实现了&nbsp;<code>Observer</code>&nbsp;的抽象类：<code>Subscriber</code>。&nbsp;<code>Subscriber</code>&nbsp;对&nbsp;<code>Observer</code>&nbsp;接口进行了一些扩展，但他们的基本使用方式是完全一样的：</p>
<div>
<pre class="prettyprint linenums">Subscriber&lt;String&gt; subscriber = new Subscriber&lt;String&gt;() {<br />
    @Override<br />
    public void onNext(String s) {<br />
        Log.d(tag, "Item: " + s);<br />
    }

    @Override<br />
    public void onCompleted() {<br />
        Log.d(tag, "Completed!");<br />
    }

    @Override<br />
    public void onError(Throwable e) {<br />
        Log.d(tag, "Error!");<br />
    }<br />
};</pre>
</div>
<p>不仅基本使用方式一样，实质上，在 RxJava 的 subscribe 过程中，<code>Observer</code>&nbsp;也总是会先被转换成一个&nbsp;<code>Subscriber</code>&nbsp;再使用。所以如果你只想使用基本功能，选择&nbsp;<code>Observer</code>&nbsp;和&nbsp;<code>Subscriber</code>&nbsp;是完全一样的。它们的区别对于使用者来说主要有两点：</p>
<ol><li><code>onStart()</code>: 这是&nbsp;<code>Subscriber</code>&nbsp;增加的方法。它会在 subscribe 刚开始，而事件还未发送之前被调用，可以用于做一些准备工作，例如数据的清零或重置。这是一个可选方法，默认情况下它的实现为空。需要注意的是，如果对准备工作的线程有要求（例如弹出一个显示进度的对话框，这必须在主线程执行），&nbsp;<code>onStart()</code>&nbsp;就不适用了，因为它总是在 subscribe 所发生的线程被调用，而不能指定线程。要在指定的线程来做准备工作，可以使用&nbsp;<code>doOnSubscribe()</code>&nbsp;方法，具体可以在后面的文中看到。</li>
<li><code>unsubscribe()</code>: 这是&nbsp;<code>Subscriber</code>&nbsp;所实现的另一个接口&nbsp;<code>Subscription</code>&nbsp;的方法，用于取消订阅。在这个方法被调用后，<code>Subscriber</code>&nbsp;将不再接收事件。一般在这个方法调用前，可以使用&nbsp;<code>isUnsubscribed()</code>&nbsp;先判断一下状态。&nbsp;<code>unsubscribe()</code>&nbsp;这个方法很重要，因为在&nbsp;<code>subscribe()</code>&nbsp;之后，&nbsp;<code>Observable</code>&nbsp;会持有&nbsp;<code>Subscriber</code>&nbsp;的引用，这个引用如果不能及时被释放，将有内存泄露的风险。所以最好保持一个原则：要在不再使用的时候尽快在合适的地方（例如&nbsp;<code>onPause()</code>&nbsp;<code>onStop()</code>&nbsp;等方法中）调用&nbsp;<code>unsubscribe()</code>&nbsp;来解除引用关系，以避免内存泄露的发生。</li></ol>
<h5>2) 创建 Observable</h5>
<p>Observable 即被观察者，它决定什么时候触发事件以及触发怎样的事件。 RxJava 使用&nbsp;<code>create()</code>&nbsp;方法来创建一个 Observable ，并为它定义事件触发规则：</p>
<div>
<pre class="prettyprint linenums">Observable observable = Observable.create(new Observable.OnSubscribe&lt;String&gt;() {<br />
    @Override<br />
    public void call(Subscriber&lt;? super String&gt; subscriber) {<br />
        subscriber.onNext("Hello");<br />
        subscriber.onNext("Hi");<br />
        subscriber.onNext("Aloha");<br />
        subscriber.onCompleted();<br />
    }<br />
});</pre>
</div>
<p>可以看到，这里传入了一个&nbsp;<code>OnSubscribe</code>&nbsp;对象作为参数。<code>OnSubscribe</code>&nbsp;会被存储在返回的&nbsp;<code>Observable</code>&nbsp;对象中，它的作用相当于一个计划表，当&nbsp;<code>Observable</code>&nbsp;被订阅的时候，<code>OnSubscribe</code>&nbsp;的&nbsp;<code>call()</code>&nbsp;方法会自动被调用，事件序列就会依照设定依次触发（对于上面的代码，就是观察者<code>Subscriber</code>&nbsp;将会被调用三次&nbsp;<code>onNext()</code>&nbsp;和一次&nbsp;<code>onCompleted()</code>）。这样，由被观察者调用了观察者的回调方法，就实现了由被观察者向观察者的事件传递，即观察者模式。</p>
<blockquote><p>这个例子很简单：事件的内容是字符串，而不是一些复杂的对象；事件的内容是已经定好了的，而不像有的观察者模式一样是待确定的（例如网络请求的结果在请求返回之前是未知的）；所有事件在一瞬间被全部发送出去，而不是夹杂一些确定或不确定的时间间隔或者经过某种触发器来触发的。总之，这个例子看起来毫无实用价值。但这是为了便于说明，实质上只要你想，各种各样的事件发送规则你都可以自己来写。至于具体怎么做，后面都会讲到，但现在不行。只有把基础原理先说明白了，上层的运用才能更容易说清楚。</p></blockquote>
<p><code>create()</code>&nbsp;方法是 RxJava 最基本的创造事件序列的方法。基于这个方法， RxJava 还提供了一些方法用来快捷创建事件队列，例如：</p>
<ul><li><code>just(T...)</code>: 将传入的参数依次发送出来。</li></ul>
<div>
<pre class="prettyprint linenums">Observable observable = Observable.just("Hello", "Hi", "Aloha");<br />
// 将会依次调用：<br />
// onNext("Hello");<br />
// onNext("Hi");<br />
// onNext("Aloha");<br />
// onCompleted();</pre>
</div>
<ul><li><code>from(T[])</code>&nbsp;/&nbsp;<code>from(Iterable&lt;? extends T&gt;)</code>&nbsp;: 将传入的数组或&nbsp;<code>Iterable</code>&nbsp;拆分成具体对象后，依次发送出来。</li></ul>
<div>
<pre class="prettyprint linenums">String[] words = {"Hello", "Hi", "Aloha"};<br />
Observable observable = Observable.from(words);<br />
// 将会依次调用：<br />
// onNext("Hello");<br />
// onNext("Hi");<br />
// onNext("Aloha");<br />
// onCompleted();</pre>
</div>
<p>上面&nbsp;<code>just(T...)</code>&nbsp;的例子和&nbsp;<code>from(T[])</code>&nbsp;的例子，都和之前的&nbsp;<code>create(OnSubscribe)</code>&nbsp;的例子是等价的。</p>
<h5>3) Subscribe (订阅)</h5>
<p>创建了&nbsp;<code>Observable</code>&nbsp;和&nbsp;<code>Observer</code>&nbsp;之后，再用&nbsp;<code>subscribe()</code>&nbsp;方法将它们联结起来，整条链子就可以工作了。代码形式很简单：</p>
<div>
<pre class="prettyprint linenums">observable.subscribe(observer);<br />
// 或者：<br />
observable.subscribe(subscriber);</pre>
</div>
<blockquote><p>有人可能会注意到，&nbsp;<code>subscribe()</code>&nbsp;这个方法有点怪：它看起来是『<code>observalbe</code>&nbsp;订阅了&nbsp;<code>observer</code>&nbsp;/&nbsp;<code>subscriber</code>』而不是『<code>observer</code>&nbsp;/&nbsp;<code>subscriber</code>&nbsp;订阅了&nbsp;<code>observalbe</code>』，这看起来就像『杂志订阅了读者』一样颠倒了对象关系。这让人读起来有点别扭，不过如果把 API 设计成&nbsp;<code>observer.subscribe(observable)</code>&nbsp;/&nbsp;<code>subscriber.subscribe(observable)</code>&nbsp;，虽然更加符合思维逻辑，但对流式 API 的设计就造成影响了，比较起来明显是得不偿失的。</p></blockquote>
<p><code>Observable.subscribe(Subscriber)</code>&nbsp;的内部实现是这样的（仅核心代码）：</p>
<div>
<pre class="prettyprint linenums">// 注意：这不是 subscribe() 的源码，而是将源码中与性能、兼容性、扩展性有关的代码剔除后的核心代码。<br />
// 如果需要看源码，可以去 RxJava 的 GitHub 仓库下载。<br />
public Subscription subscribe(Subscriber subscriber) {<br />
    subscriber.onStart();<br />
    onSubscribe.call(subscriber);<br />
    return subscriber;<br />
}</pre>
</div>
<p>可以看到，<code>subscriber()</code>&nbsp;做了3件事：</p>
<ol><li>调用&nbsp;<code>Subscriber.onStart()</code>&nbsp;。这个方法在前面已经介绍过，是一个可选的准备方法。</li>
<li>调用&nbsp;<code>Observable</code>&nbsp;中的&nbsp;<code>OnSubscribe.call(Subscriber)</code>&nbsp;。在这里，事件发送的逻辑开始运行。从这也可以看出，在 RxJava 中，&nbsp;<code>Observable</code>&nbsp;并不是在创建的时候就立即开始发送事件，而是在它被订阅的时候，即当&nbsp;<code>subscribe()</code>&nbsp;方法执行的时候。</li>
<li>将传入的&nbsp;<code>Subscriber</code>&nbsp;作为&nbsp;<code>Subscription</code>&nbsp;返回。这是为了方便&nbsp;<code>unsubscribe()</code>.</li></ol>
<p>整个过程中对象间的关系如下图：</p>
<p><img referrerpolicy="no-referrer"src="http://ww4.sinaimg.cn/mw1024/52eb2279jw1f2rx489robj20lk0a8my2.jpg" data-src="http://ww4.sinaimg.cn/mw1024/52eb2279jw1f2rx489robj20lk0a8my2.jpg" /></p>
<p>或者可以看动图：</p>
<p><img referrerpolicy="no-referrer"src="http://ww3.sinaimg.cn/mw1024/52eb2279jw1f2rx4ay0hrg20ig08wk4q.gif" data-src="http://ww3.sinaimg.cn/mw1024/52eb2279jw1f2rx4ay0hrg20ig08wk4q.gif" /></p>
<p>除了&nbsp;<code>subscribe(Observer)</code>&nbsp;和&nbsp;<code>subscribe(Subscriber)</code>&nbsp;，<code>subscribe()</code>&nbsp;还支持不完整定义的回调，RxJava 会自动根据定义创建出&nbsp;<code>Subscriber</code>&nbsp;。形式如下：</p>
<div>
<pre class="prettyprint linenums">Action1&lt;String&gt; onNextAction = new Action1&lt;String&gt;() {<br />
    // onNext()<br />
    @Override<br />
    public void call(String s) {<br />
        Log.d(tag, s);<br />
    }<br />
};<br />
Action1&lt;Throwable&gt; onErrorAction = new Action1&lt;Throwable&gt;() {<br />
    // onError()<br />
    @Override<br />
    public void call(Throwable throwable) {<br />
        // Error handling<br />
    }<br />
};<br />
Action0 onCompletedAction = new Action0() {<br />
    // onCompleted()<br />
    @Override<br />
    public void call() {<br />
        Log.d(tag, "completed");<br />
    }<br />
};

// 自动创建 Subscriber ，并使用 onNextAction 来定义 onNext()<br />
observable.subscribe(onNextAction);<br />
// 自动创建 Subscriber ，并使用 onNextAction 和 onErrorAction 来定义 onNext() 和 onError()<br />
observable.subscribe(onNextAction, onErrorAction);<br />
// 自动创建 Subscriber ，并使用 onNextAction、 onErrorAction 和 onCompletedAction 来定义 onNext()、 onError() 和 onCompleted()<br />
observable.subscribe(onNextAction, onErrorAction, onCompletedAction);</pre>
</div>
<p>简单解释一下这段代码中出现的&nbsp;<code>Action1</code>&nbsp;和&nbsp;<code>Action0</code>。&nbsp;<code>Action0</code>&nbsp;是 RxJava 的一个接口，它只有一个方法&nbsp;<code>call()</code>，这个方法是无参无返回值的；由于&nbsp;<code>onCompleted()</code>&nbsp;方法也是无参无返回值的，因此&nbsp;<code>Action0</code>&nbsp;可以被当成一个包装对象，将&nbsp;<code>onCompleted()</code>&nbsp;的内容打包起来将自己作为一个参数传入&nbsp;<code>subscribe()</code>&nbsp;以实现不完整定义的回调。这样其实也可以看做将&nbsp;<code>onCompleted()</code>&nbsp;方法作为参数传进了&nbsp;<code>subscribe()</code>，相当于其他某些语言中的『闭包』。&nbsp;<code>Action1</code>&nbsp;也是一个接口，它同样只有一个方法&nbsp;<code>call(T param)</code>，这个方法也无返回值，但有一个参数；与&nbsp;<code>Action0</code>&nbsp;同理，由于&nbsp;<code>onNext(T obj)</code>&nbsp;和&nbsp;<code>onError(Throwable error)</code>&nbsp;也是单参数无返回值的，因此&nbsp;<code>Action1</code>&nbsp;可以将&nbsp;<code>onNext(obj)</code>&nbsp;和&nbsp;<code>onError(error)</code>&nbsp;打包起来传入&nbsp;<code>subscribe()</code>&nbsp;以实现不完整定义的回调。事实上，虽然&nbsp;<code>Action0</code>&nbsp;和&nbsp;<code>Action1</code>&nbsp;在 API 中使用最广泛，但 RxJava 是提供了多个&nbsp;<code>ActionX</code>&nbsp;形式的接口 (例如&nbsp;<code>Action2</code>,&nbsp;<code>Action3</code>) 的，它们可以被用以包装不同的无返回值的方法。</p>
<blockquote><p>注：正如前面所提到的，<code>Observer</code>&nbsp;和&nbsp;<code>Subscriber</code>&nbsp;具有相同的角色，而且&nbsp;<code>Observer</code>&nbsp;在&nbsp;<code>subscribe()</code>&nbsp;过程中最终会被转换成&nbsp;<code>Subscriber</code>&nbsp;对象，因此，从这里开始，后面的描述我将用&nbsp;<code>Subscriber</code>&nbsp;来代替&nbsp;<code>Observer</code>&nbsp;，这样更加严谨。</p></blockquote>
<h5>4) 场景示例</h5>
<p>下面举两个例子：</p>
<blockquote><p>为了把原理用更清晰的方式表述出来，本文中挑选的都是功能尽可能简单的例子，以至于有些示例代码看起来会有『画蛇添足』『明明不用 RxJava 可以更简便地解决问题』的感觉。当你看到这种情况，不要觉得是因为 RxJava 太啰嗦，而是因为在过早的时候举出真实场景的例子并不利于原理的解析，因此我刻意挑选了简单的情景。</p></blockquote>
<h6>a. 打印字符串数组</h6>
<p>将字符串数组&nbsp;<code>names</code>&nbsp;中的所有字符串依次打印出来：</p>
<div>
<pre class="prettyprint linenums">String[] names = ...;<br />
Observable.from(names)<br />
    .subscribe(new Action1&lt;String&gt;() {<br />
        @Override<br />
        public void call(String name) {<br />
            Log.d(tag, name);<br />
        }<br />
    });</pre>
</div>
<h6>b. 由 id 取得图片并显示</h6>
<p>由指定的一个 drawable 文件 id&nbsp;<code>drawableRes</code>&nbsp;取得图片，并显示在&nbsp;<code>ImageView</code>&nbsp;中，并在出现异常的时候打印 Toast 报错：</p>
<div>
<pre class="prettyprint linenums">int drawableRes = ...;<br />
ImageView imageView = ...;<br />
Observable.create(new OnSubscribe&lt;Drawable&gt;() {<br />
    @Override<br />
    public void call(Subscriber&lt;? super Drawable&gt; subscriber) {<br />
        Drawable drawable = getTheme().getDrawable(drawableRes));<br />
        subscriber.onNext(drawable);<br />
        subscriber.onCompleted();<br />
    }<br />
}).subscribe(new Observer&lt;Drawable&gt;() {<br />
    @Override<br />
    public void onNext(Drawable drawable) {<br />
        imageView.setImageDrawable(drawable);<br />
    }

    @Override<br />
    public void onCompleted() {<br />
    }

    @Override<br />
    public void onError(Throwable e) {<br />
        Toast.makeText(activity, "Error!", Toast.LENGTH_SHORT).show();<br />
    }<br />
});</pre>
</div>
<p>正如上面两个例子这样，创建出&nbsp;<code>Observable</code>&nbsp;和&nbsp;<code>Subscriber</code>&nbsp;，再用&nbsp;<code>subscribe()</code>&nbsp;将它们串起来，一次 RxJava 的基本使用就完成了。非常简单。</p>
<p>然而，</p>
<p><img referrerpolicy="no-referrer"src="http://ww3.sinaimg.cn/mw1024/52eb2279jw1f2rx4ddcncj2046053gll.jpg" data-src="http://ww3.sinaimg.cn/mw1024/52eb2279jw1f2rx4ddcncj2046053gll.jpg" /></p>
<p>在 RxJava 的默认规则中，事件的发出和消费都是在同一个线程的。也就是说，如果只用上面的方法，实现出来的只是一个同步的观察者模式。观察者模式本身的目的就是『后台处理，前台回调』的异步机制，因此异步对于 RxJava 是至关重要的。而要实现异步，则需要用到 RxJava 的另一个概念：&nbsp;<code>Scheduler</code>&nbsp;。</p>
<h4>3. 线程控制 &mdash;&mdash; Scheduler (一)</h4>
<p>在不指定线程的情况下， RxJava 遵循的是线程不变的原则，即：在哪个线程调用&nbsp;<code>subscribe()</code>，就在哪个线程生产事件；在哪个线程生产事件，就在哪个线程消费事件。如果需要切换线程，就需要用到&nbsp;<code>Scheduler</code>&nbsp;（调度器）。</p>
<h5>1) Scheduler 的 API (一)</h5>
<p>在RxJava 中，<code>Scheduler</code>&nbsp;&mdash;&mdash;调度器，相当于线程控制器，RxJava 通过它来指定每一段代码应该运行在什么样的线程。RxJava 已经内置了几个&nbsp;<code>Scheduler</code>&nbsp;，它们已经适合大多数的使用场景：</p>
<ul><li><code>Schedulers.immediate()</code>: 直接在当前线程运行，相当于不指定线程。这是默认的&nbsp;<code>Scheduler</code>。</li>
<li><code>Schedulers.newThread()</code>: 总是启用新线程，并在新线程执行操作。</li>
<li><code>Schedulers.io()</code>: I/O 操作（读写文件、读写数据库、网络信息交互等）所使用的&nbsp;<code>Scheduler</code>。行为模式和&nbsp;<code>newThread()</code>&nbsp;差不多，区别在于&nbsp;<code>io()</code>&nbsp;的内部实现是是用一个无数量上限的线程池，可以重用空闲的线程，因此多数情况下&nbsp;<code>io()</code>&nbsp;比&nbsp;<code>newThread()</code>&nbsp;更有效率。不要把计算工作放在&nbsp;<code>io()</code>&nbsp;中，可以避免创建不必要的线程。</li>
<li><code>Schedulers.computation()</code>: 计算所使用的&nbsp;<code>Scheduler</code>。这个计算指的是 CPU 密集型计算，即不会被 I/O 等操作限制性能的操作，例如图形的计算。这个&nbsp;<code>Scheduler</code>&nbsp;使用的固定的线程池，大小为 CPU 核数。不要把 I/O 操作放在&nbsp;<code>computation()</code>&nbsp;中，否则 I/O 操作的等待时间会浪费 CPU。</li>
<li>另外， Android 还有一个专用的&nbsp;<code>AndroidSchedulers.mainThread()</code>，它指定的操作将在 Android 主线程运行。</li></ul>
<p>有了这几个&nbsp;<code>Scheduler</code>&nbsp;，就可以使用&nbsp;<code>subscribeOn()</code>&nbsp;和&nbsp;<code>observeOn()</code>&nbsp;两个方法来对线程进行控制了。 *&nbsp;<code>subscribeOn()</code>: 指定&nbsp;<code>subscribe()</code>&nbsp;所发生的线程，即&nbsp;<code>Observable.OnSubscribe</code>&nbsp;被激活时所处的线程。或者叫做事件产生的线程。 *&nbsp;<code>observeOn()</code>: 指定&nbsp;<code>Subscriber</code>&nbsp;所运行在的线程。或者叫做事件消费的线程。</p>
<p>文字叙述总归难理解，上代码：</p>
<div>
<pre class="prettyprint linenums">Observable.just(1, 2, 3, 4)<br />
    .subscribeOn(Schedulers.io()) // 指定 subscribe() 发生在 IO 线程<br />
    .observeOn(AndroidSchedulers.mainThread()) // 指定 Subscriber 的回调发生在主线程<br />
    .subscribe(new Action1&lt;Integer&gt;() {<br />
        @Override<br />
        public void call(Integer number) {<br />
            Log.d(tag, "number:" + number);<br />
        }<br />
    });</pre>
</div>
<p>上面这段代码中，由于&nbsp;<code>subscribeOn(Schedulers.io())</code>&nbsp;的指定，被创建的事件的内容&nbsp;<code>1</code>、<code>2</code>、<code>3</code>、<code>4</code>&nbsp;将会在 IO 线程发出；而由于&nbsp;<code>observeOn(AndroidScheculers.mainThread()</code>) 的指定，因此&nbsp;<code>subscriber</code>&nbsp;数字的打印将发生在主线程 。事实上，这种在&nbsp;<code>subscribe()</code>&nbsp;之前写上两句&nbsp;<code>subscribeOn(Scheduler.io())</code>&nbsp;和&nbsp;<code>observeOn(AndroidSchedulers.mainThread())</code>&nbsp;的使用方式非常常见，它适用于多数的 『后台线程取数据，主线程显示』的程序策略。</p>
<p>而前面提到的由图片 id 取得图片并显示的例子，如果也加上这两句：</p>
<div>
<pre class="prettyprint linenums">int drawableRes = ...;<br />
ImageView imageView = ...;<br />
Observable.create(new OnSubscribe&lt;Drawable&gt;() {<br />
    @Override<br />
    public void call(Subscriber&lt;? super Drawable&gt; subscriber) {<br />
        Drawable drawable = getTheme().getDrawable(drawableRes));<br />
        subscriber.onNext(drawable);<br />
        subscriber.onCompleted();<br />
    }<br />
})<br />
.subscribeOn(Schedulers.io()) // 指定 subscribe() 发生在 IO 线程<br />
.observeOn(AndroidSchedulers.mainThread()) // 指定 Subscriber 的回调发生在主线程<br />
.subscribe(new Observer&lt;Drawable&gt;() {<br />
    @Override<br />
    public void onNext(Drawable drawable) {<br />
        imageView.setImageDrawable(drawable);<br />
    }

    @Override<br />
    public void onCompleted() {<br />
    }

    @Override<br />
    public void onError(Throwable e) {<br />
        Toast.makeText(activity, "Error!", Toast.LENGTH_SHORT).show();<br />
    }<br />
});</pre>
</div>
<p>那么，加载图片将会发生在 IO 线程，而设置图片则被设定在了主线程。这就意味着，即使加载图片耗费了几十甚至几百毫秒的时间，也不会造成丝毫界面的卡顿。</p>
<h5>2) Scheduler 的原理 (一)</h5>
<p>RxJava 的 Scheduler API 很方便，也很神奇（加了一句话就把线程切换了，怎么做到的？而且&nbsp;<code>subscribe()</code>不是最外层直接调用的方法吗，它竟然也能被指定线程？）。然而 Scheduler 的原理需要放在后面讲，因为它的原理是以下一节《变换》的原理作为基础的。</p>
<p>好吧这一节其实我屁也没说，只是为了让你安心，让你知道我不是忘了讲原理，而是把它放在了更合适的地方。</p>
<h4>4. 变换</h4>
<p>终于要到牛逼的地方了，不管你激动不激动，反正我是激动了。</p>
<p>RxJava 提供了对事件序列进行变换的支持，这是它的核心功能之一，也是大多数人说『RxJava 真是太好用了』的最大原因。<strong>所谓变换，就是将事件序列中的对象或整个序列进行加工处理，转换成不同的事件或事件序列。</strong>概念说着总是模糊难懂的，来看 API。</p>
<h5>1) API</h5>
<p>首先看一个&nbsp;<code>map()</code>&nbsp;的例子：</p>
<div>
<pre class="prettyprint linenums">Observable.just("images/logo.png") // 输入类型 String<br />
    .map(new Func1&lt;String, Bitmap&gt;() {<br />
        @Override<br />
        public Bitmap call(String filePath) { // 参数类型 String<br />
            return getBitmapFromPath(filePath); // 返回类型 Bitmap<br />
        }<br />
    })<br />
    .subscribe(new Action1&lt;Bitmap&gt;() {<br />
        @Override<br />
        public void call(Bitmap bitmap) { // 参数类型 Bitmap<br />
            showBitmap(bitmap);<br />
        }<br />
    });</pre>
</div>
<p>这里出现了一个叫做&nbsp;<code>Func1</code>&nbsp;的类。它和&nbsp;<code>Action1</code>&nbsp;非常相似，也是 RxJava 的一个接口，用于包装含有一个参数的方法。&nbsp;<code>Func1</code>&nbsp;和&nbsp;<code>Action</code>&nbsp;的区别在于，&nbsp;<code>Func1</code>&nbsp;包装的是有返回值的方法。另外，和&nbsp;<code>ActionX</code>&nbsp;一样，&nbsp;<code>FuncX</code>也有多个，用于不同参数个数的方法。<code>FuncX</code>&nbsp;和&nbsp;<code>ActionX</code>&nbsp;的区别在&nbsp;<code>FuncX</code>&nbsp;包装的是有返回值的方法。</p>
<p>可以看到，<code>map()</code>&nbsp;方法将参数中的&nbsp;<code>String</code>&nbsp;对象转换成一个&nbsp;<code>Bitmap</code>&nbsp;对象后返回，而在经过&nbsp;<code>map()</code>&nbsp;方法后，事件的参数类型也由&nbsp;<code>String</code>&nbsp;转为了&nbsp;<code>Bitmap</code>。这种直接变换对象并返回的，是最常见的也最容易理解的变换。不过 RxJava 的变换远不止这样，它不仅可以针对事件对象，还可以针对整个事件队列，这使得 RxJava 变得非常灵活。我列举几个常用的变换：</p>
<ul><li><p><code>map()</code>: 事件对象的直接变换，具体功能上面已经介绍过。它是 RxJava 最常用的变换。&nbsp;<code>map()</code>&nbsp;的示意图：<img referrerpolicy="no-referrer"src="http://ww1.sinaimg.cn/mw1024/52eb2279jw1f2rx4fitvfj20hw0ea0tg.jpg" data-src="http://ww1.sinaimg.cn/mw1024/52eb2279jw1f2rx4fitvfj20hw0ea0tg.jpg" /></p></li>
<li><p><code>flatMap()</code>: 这是一个很有用但<strong>非常难理解</strong>的变换，因此我决定花多些篇幅来介绍它。 首先假设这么一种需求：假设有一个数据结构『学生』，现在需要打印出一组学生的名字。实现方式很简单：</p></li></ul>
<div>
<pre class="prettyprint linenums">Student[] students = ...;<br />
Subscriber&lt;String&gt; subscriber = new Subscriber&lt;String&gt;() {<br />
    @Override<br />
    public void onNext(String name) {<br />
        Log.d(tag, name);<br />
    }<br />
    ...<br />
};<br />
Observable.from(students)<br />
    .map(new Func1&lt;Student, String&gt;() {<br />
        @Override<br />
        public String call(Student student) {<br />
            return student.getName();<br />
        }<br />
    })<br />
    .subscribe(subscriber);</pre>
</div>
<p>很简单。那么再假设：如果要打印出每个学生所需要修的所有课程的名称呢？（需求的区别在于，每个学生只有一个名字，但却有多个课程。）首先可以这样实现：</p>
<div>
<pre class="prettyprint linenums">Student[] students = ...;<br />
Subscriber&lt;Student&gt; subscriber = new Subscriber&lt;Student&gt;() {<br />
    @Override<br />
    public void onNext(Student student) {<br />
        List&lt;Course&gt; courses = student.getCourses();<br />
        for (int i = 0; i &lt; courses.size(); i++) {<br />
            Course course = courses.get(i);<br />
            Log.d(tag, course.getName());<br />
        }<br />
    }<br />
    ...<br />
};<br />
Observable.from(students)<br />
    .subscribe(subscriber);</pre>
</div>
<p>依然很简单。那么如果我不想在&nbsp;<code>Subscriber</code>&nbsp;中使用 for 循环，而是希望&nbsp;<code>Subscriber</code>&nbsp;中直接传入单个的&nbsp;<code>Course</code>&nbsp;对象呢（这对于代码复用很重要）？用&nbsp;<code>map()</code>&nbsp;显然是不行的，因为&nbsp;<code>map()</code>&nbsp;是一对一的转化，而我现在的要求是一对多的转化。那怎么才能把一个 Student 转化成多个 Course 呢？</p>
<p>这个时候，就需要用&nbsp;<code>flatMap()</code>&nbsp;了：</p>
<div>
<pre class="prettyprint linenums">Student[] students = ...;<br />
Subscriber&lt;Course&gt; subscriber = new Subscriber&lt;Course&gt;() {<br />
    @Override<br />
    public void onNext(Course course) {<br />
        Log.d(tag, course.getName());<br />
    }<br />
    ...<br />
};<br />
Observable.from(students)<br />
    .flatMap(new Func1&lt;Student, Observable&lt;Course&gt;&gt;() {<br />
        @Override<br />
        public Observable&lt;Course&gt; call(Student student) {<br />
            return Observable.from(student.getCourses());<br />
        }<br />
    })<br />
    .subscribe(subscriber);</pre>
</div>
<p>从上面的代码可以看出，&nbsp;<code>flatMap()</code>&nbsp;和&nbsp;<code>map()</code>&nbsp;有一个相同点：它也是把传入的参数转化之后返回另一个对象。但需要注意，和&nbsp;<code>map()</code>&nbsp;不同的是，&nbsp;<code>flatMap()</code>&nbsp;中返回的是个&nbsp;<code>Observable</code>&nbsp;对象，并且这个&nbsp;<code>Observable</code>&nbsp;对象并不是被直接发送到了&nbsp;<code>Subscriber</code>&nbsp;的回调方法中。&nbsp;<code>flatMap()</code>&nbsp;的原理是这样的：1. 使用传入的事件对象创建一个&nbsp;<code>Observable</code>&nbsp;对象；2. 并不发送这个&nbsp;<code>Observable</code>, 而是将它激活，于是它开始发送事件；3. 每一个创建出来的&nbsp;<code>Observable</code>&nbsp;发送的事件，都被汇入同一个&nbsp;<code>Observable</code>&nbsp;，而这个&nbsp;<code>Observable</code>&nbsp;负责将这些事件统一交给&nbsp;<code>Subscriber</code>&nbsp;的回调方法。这三个步骤，把事件拆成了两级，通过一组新创建的&nbsp;<code>Observable</code>&nbsp;将初始的对象『铺平』之后通过统一路径分发了下去。而这个『铺平』就是&nbsp;<code>flatMap()</code>&nbsp;所谓的 flat。</p>
<p><code>flatMap()</code>&nbsp;示意图：</p>
<p><img referrerpolicy="no-referrer"src="http://ww1.sinaimg.cn/mw1024/52eb2279jw1f2rx4i8da2j20hg0dydgx.jpg" data-src="http://ww1.sinaimg.cn/mw1024/52eb2279jw1f2rx4i8da2j20hg0dydgx.jpg" /></p>
<p>扩展：由于可以在嵌套的&nbsp;<code>Observable</code>&nbsp;中添加异步代码，&nbsp;<code>flatMap()</code>&nbsp;也常用于嵌套的异步操作，例如嵌套的网络请求。示例代码（Retrofit + RxJava）：</p>
<div>
<pre class="prettyprint linenums">networkClient.token() // 返回 Observable&lt;String&gt;，在订阅时请求 token，并在响应后发送 token<br />
    .flatMap(new Func1&lt;String, Observable&lt;Messages&gt;&gt;() {<br />
        @Override<br />
        public Observable&lt;Messages&gt; call(String token) {<br />
            // 返回 Observable&lt;Messages&gt;，在订阅时请求消息列表，并在响应后发送请求到的消息列表<br />
            return networkClient.messages();<br />
        }<br />
    })<br />
    .subscribe(new Action1&lt;Messages&gt;() {<br />
        @Override<br />
        public void call(Messages messages) {<br />
            // 处理显示消息列表<br />
            showMessages(messages);<br />
        }<br />
    });</pre>
</div>
<p>传统的嵌套请求需要使用嵌套的 Callback 来实现。而通过&nbsp;<code>flatMap()</code>&nbsp;，可以把嵌套的请求写在一条链中，从而保持程序逻辑的清晰。</p>
<ul><li><code>throttleFirst()</code>: 在每次事件触发后的一定时间间隔内丢弃新的事件。常用作去抖动过滤，例如按钮的点击监听器：<code>RxView.clickEvents(button) // RxBinding 代码，后面的文章有解释 .throttleFirst(500, TimeUnit.MILLISECONDS) // 设置防抖间隔为 500ms .subscribe(subscriber);</code>妈妈再也不怕我的用户手抖点开两个重复的界面啦。</li></ul>
<p>此外， RxJava 还提供很多便捷的方法来实现事件序列的变换，这里就不一一举例了。</p>
<h5>2) 变换的原理：lift()</h5>
<p>这些变换虽然功能各有不同，但实质上都是<strong>针对事件序列的处理和再发送</strong>。而在 RxJava 的内部，它们是基于同一个基础的变换方法：&nbsp;<code>lift(Operator)</code>。首先看一下&nbsp;<code>lift()</code>&nbsp;的内部实现（仅核心代码）：</p>
<div>
<pre class="prettyprint linenums">// 注意：这不是 lift() 的源码，而是将源码中与性能、兼容性、扩展性有关的代码剔除后的核心代码。<br />
// 如果需要看源码，可以去 RxJava 的 GitHub 仓库下载。<br />
public &lt;R&gt; Observable&lt;R&gt; lift(Operator&lt;? extends R, ? super T&gt; operator) {<br />
    return Observable.create(new OnSubscribe&lt;R&gt;() {<br />
        @Override<br />
        public void call(Subscriber subscriber) {<br />
            Subscriber newSubscriber = operator.call(subscriber);<br />
            newSubscriber.onStart();<br />
            onSubscribe.call(newSubscriber);<br />
        }<br />
    });<br />
}</pre>
</div>
<p>这段代码很有意思：它生成了一个新的&nbsp;<code>Observable</code>&nbsp;并返回，而且创建新&nbsp;<code>Observable</code>&nbsp;所用的参数&nbsp;<code>OnSubscribe</code>&nbsp;的回调方法&nbsp;<code>call()</code>&nbsp;中的实现竟然看起来和前面讲过的&nbsp;<code>Observable.subscribe()</code>&nbsp;一样！然而它们并不一样哟~不一样的地方关键就在于第二行&nbsp;<code>onSubscribe.call(subscriber)</code>&nbsp;中的&nbsp;<strong><code>onSubscribe</code>&nbsp;所指代的对象不同</strong>（高能预警：接下来的几句话可能会导致身体的严重不适）&mdash;&mdash;</p>
<ul><li><code>subscribe()</code>&nbsp;中这句话的&nbsp;<code>onSubscribe</code>&nbsp;指的是&nbsp;<code>Observable</code>&nbsp;中的&nbsp;<code>onSubscribe</code>&nbsp;对象，这个没有问题，但是&nbsp;<code>lift()</code>&nbsp;之后的情况就复杂了点。</li>
<li>当含有&nbsp;<code>lift()</code>&nbsp;时：&nbsp;<br />1.<code>lift()</code>&nbsp;创建了一个&nbsp;<code>Observable</code>&nbsp;后，加上之前的原始&nbsp;<code>Observable</code>，已经有两个&nbsp;<code>Observable</code>&nbsp;了；&nbsp;<br />2.而同样地，新&nbsp;<code>Observable</code>&nbsp;里的新&nbsp;<code>OnSubscribe</code>&nbsp;加上之前的原始&nbsp;<code>Observable</code>&nbsp;中的原始&nbsp;<code>OnSubscribe</code>，也就有了两个&nbsp;<code>OnSubscribe</code>；&nbsp;<br />3.当用户调用经过&nbsp;<code>lift()</code>&nbsp;后的&nbsp;<code>Observable</code>&nbsp;的&nbsp;<code>subscribe()</code>&nbsp;的时候，使用的是&nbsp;<code>lift()</code>&nbsp;所返回的新的&nbsp;<code>Observable</code>&nbsp;，于是它所触发的&nbsp;<code>onSubscribe.call(subscriber)</code>，也是用的新&nbsp;<code>Observable</code>&nbsp;中的新&nbsp;<code>OnSubscribe</code>，即在&nbsp;<code>lift()</code>&nbsp;中生成的那个&nbsp;<code>OnSubscribe</code>；&nbsp;<br />4.而这个新&nbsp;<code>OnSubscribe</code>&nbsp;的&nbsp;<code>call()</code>&nbsp;方法中的&nbsp;<code>onSubscribe</code>&nbsp;，就是指的原始&nbsp;<code>Observable</code>&nbsp;中的原始&nbsp;<code>OnSubscribe</code>&nbsp;，在这个&nbsp;<code>call()</code>&nbsp;方法里，新&nbsp;<code>OnSubscribe</code>&nbsp;利用&nbsp;<code>operator.call(subscriber)</code>&nbsp;生成了一个新的&nbsp;<code>Subscriber</code>（<code>Operator</code>&nbsp;就是在这里，通过自己的&nbsp;<code>call()</code>&nbsp;方法将新&nbsp;<code>Subscriber</code>&nbsp;和原始&nbsp;<code>Subscriber</code>进行关联，并插入自己的『变换』代码以实现变换），然后利用这个新&nbsp;<code>Subscriber</code>&nbsp;向原始&nbsp;<code>Observable</code>&nbsp;进行订阅。&nbsp;<br />这样就实现了&nbsp;<code>lift()</code>&nbsp;过程，有点<strong>像一种代理机制，通过事件拦截和处理实现事件序列的变换。</strong></li></ul>
<p>精简掉细节的话，也可以这么说：在&nbsp;<code>Observable</code>&nbsp;执行了&nbsp;<code>lift(Operator)</code>&nbsp;方法之后，会返回一个新的&nbsp;<code>Observable</code>，这个新的&nbsp;<code>Observable</code>&nbsp;会像一个代理一样，负责接收原始的&nbsp;<code>Observable</code>&nbsp;发出的事件，并在处理后发送给&nbsp;<code>Subscriber</code>。</p>
<p>如果你更喜欢具象思维，可以看图：</p>
<p><img referrerpolicy="no-referrer"src="http://ww1.sinaimg.cn/mw1024/52eb2279jw1f2rxcrna27j20h40d1q4f.jpg" data-src="http://ww1.sinaimg.cn/mw1024/52eb2279jw1f2rxcrna27j20h40d1q4f.jpg" /></p>
<p>或者可以看动图：</p>
<p><img referrerpolicy="no-referrer"src="http://ww4.sinaimg.cn/mw1024/52eb2279jw1f2rxcu9f46g20go0cz4qp.gif" data-src="http://ww4.sinaimg.cn/mw1024/52eb2279jw1f2rxcu9f46g20go0cz4qp.gif" /></p>
<p>两次和多次的&nbsp;<code>lift()</code>&nbsp;同理，如下图：</p>
<p><img referrerpolicy="no-referrer"src="http://ww1.sinaimg.cn/mw1024/52eb2279jw1f2rxcvophmj20h30hl0v3.jpg" data-src="http://ww1.sinaimg.cn/mw1024/52eb2279jw1f2rxcvophmj20h30hl0v3.jpg" /></p>
<p>举一个具体的&nbsp;<code>Operator</code>&nbsp;的实现。下面这是一个将事件中的&nbsp;<code>Integer</code>&nbsp;对象转换成&nbsp;<code>String</code>&nbsp;的例子，仅供参考：</p>
<div>
<pre class="prettyprint linenums">observable.lift(new Observable.Operator&lt;String, Integer&gt;() {<br />
    @Override<br />
    public Subscriber&lt;? super Integer&gt; call(final Subscriber&lt;? super String&gt; subscriber) {<br />
        // 将事件序列中的 Integer 对象转换为 String 对象<br />
        return new Subscriber&lt;Integer&gt;() {<br />
            @Override<br />
            public void onNext(Integer integer) {<br />
                subscriber.onNext("" + integer);<br />
            }

            @Override<br />
            public void onCompleted() {<br />
                subscriber.onCompleted();<br />
            }

            @Override<br />
            public void onError(Throwable e) {<br />
                subscriber.onError(e);<br />
            }<br />
        };<br />
    }<br />
});</pre>
</div>
<blockquote><p>讲述&nbsp;<code>lift()</code>&nbsp;的原理只是为了让你更好地了解 RxJava ，从而可以更好地使用它。然而不管你是否理解了&nbsp;<code>lift()</code>的原理，RxJava 都不建议开发者自定义&nbsp;<code>Operator</code>&nbsp;来直接使用&nbsp;<code>lift()</code>，而是建议尽量使用已有的&nbsp;<code>lift()</code>&nbsp;包装方法（如&nbsp;<code>map()</code>&nbsp;<code>flatMap()</code>&nbsp;等）进行组合来实现需求，因为直接使用 lift() 非常容易发生一些难以发现的错误。</p></blockquote>
<h5>3) compose: 对 Observable 整体的变换</h5>
<p>除了&nbsp;<code>lift()</code>&nbsp;之外，&nbsp;<code>Observable</code>&nbsp;还有一个变换方法叫做&nbsp;<code>compose(Transformer)</code>。它和&nbsp;<code>lift()</code>&nbsp;的区别在于，&nbsp;<strong><code>lift()</code>&nbsp;是针对事件项和事件序列的，而&nbsp;<code>compose()</code>&nbsp;是针对&nbsp;<code>Observable</code>&nbsp;自身进行变换。</strong>举个例子，假设在程序中有多个&nbsp;<code>Observable</code>&nbsp;，并且他们都需要应用一组相同的&nbsp;<code>lift()</code>&nbsp;变换。你可以这么写：</p>
<div>
<pre class="prettyprint linenums">observable1<br />
    .lift1()<br />
    .lift2()<br />
    .lift3()<br />
    .lift4()<br />
    .subscribe(subscriber1);<br />
observable2<br />
    .lift1()<br />
    .lift2()<br />
    .lift3()<br />
    .lift4()<br />
    .subscribe(subscriber2);<br />
observable3<br />
    .lift1()<br />
    .lift2()<br />
    .lift3()<br />
    .lift4()<br />
    .subscribe(subscriber3);<br />
observable4<br />
    .lift1()<br />
    .lift2()<br />
    .lift3()<br />
    .lift4()<br />
    .subscribe(subscriber1);</pre>
</div>
<p>你觉得这样太不软件工程了，于是你改成了这样：</p>
<div>
<pre class="prettyprint linenums">private Observable liftAll(Observable observable) {<br />
    return observable<br />
        .lift1()<br />
        .lift2()<br />
        .lift3()<br />
        .lift4();<br />
}<br />
...<br />
liftAll(observable1).subscribe(subscriber1);<br />
liftAll(observable2).subscribe(subscriber2);<br />
liftAll(observable3).subscribe(subscriber3);<br />
liftAll(observable4).subscribe(subscriber4);</pre>
</div>
<p>可读性、可维护性都提高了。可是&nbsp;<code>Observable</code>&nbsp;被一个方法包起来，这种方式对于&nbsp;<code>Observale</code>&nbsp;的灵活性似乎还是增添了那么点限制。怎么办？这个时候，就应该用&nbsp;<code>compose()</code>&nbsp;来解决了：</p>
<div>
<pre class="prettyprint linenums">public class LiftAllTransformer implements Observable.Transformer&lt;Integer, String&gt; {<br />
    @Override<br />
    public Observable&lt;String&gt; call(Observable&lt;Integer&gt; observable) {<br />
        return observable<br />
            .lift1()<br />
            .lift2()<br />
            .lift3()<br />
            .lift4();<br />
    }<br />
}<br />
...<br />
Transformer liftAll = new LiftAllTransformer();<br />
observable1.compose(liftAll).subscribe(subscriber1);<br />
observable2.compose(liftAll).subscribe(subscriber2);<br />
observable3.compose(liftAll).subscribe(subscriber3);<br />
observable4.compose(liftAll).subscribe(subscriber4);</pre>
</div>
<p>像上面这样，使用&nbsp;<code>compose()</code>&nbsp;方法，<code>Observable</code>&nbsp;可以利用传入的&nbsp;<code>Transformer</code>&nbsp;对象的&nbsp;<code>call</code>&nbsp;方法直接对自身进行处理，也就不必被包在方法的里面了。</p>
<p><code>compose()</code>&nbsp;的原理比较简单，不附图喽。</p>
<h4>5. 线程控制：Scheduler (二)</h4>
<p>除了灵活的变换，RxJava 另一个牛逼的地方，就是线程的自由控制。</p>
<h5>1) Scheduler 的 API (二)</h5>
<p>前面讲到了，可以利用&nbsp;<code>subscribeOn()</code>&nbsp;结合&nbsp;<code>observeOn()</code>&nbsp;来实现线程控制，让事件的产生和消费发生在不同的线程。可是在了解了&nbsp;<code>map()</code>&nbsp;<code>flatMap()</code>&nbsp;等变换方法后，有些好事的（其实就是当初刚接触 RxJava 时的我）就问了：能不能多切换几次线程？</p>
<p>答案是：能。因为&nbsp;<code>observeOn()</code>&nbsp;指定的是&nbsp;<code>Subscriber</code>&nbsp;的线程，而这个&nbsp;<code>Subscriber</code>&nbsp;并不是（严格说应该为『不一定是』，但这里不妨理解为『不是』）<code>subscribe()</code>&nbsp;参数中的&nbsp;<code>Subscriber</code>&nbsp;，而是&nbsp;<code>observeOn()</code>&nbsp;执行时的当前&nbsp;<code>Observable</code>&nbsp;所对应的&nbsp;<code>Subscriber</code>&nbsp;，即它的直接下级&nbsp;<code>Subscriber</code>&nbsp;。换句话说，<code>observeOn()</code>&nbsp;指定的是它之后的操作所在的线程。因此如果有多次切换线程的需求，只要在每个想要切换线程的位置调用一次&nbsp;<code>observeOn()</code>&nbsp;即可。上代码：</p>
<div>
<pre class="prettyprint linenums">Observable.just(1, 2, 3, 4) // IO 线程，由 subscribeOn() 指定<br />
    .subscribeOn(Schedulers.io())<br />
    .observeOn(Schedulers.newThread())<br />
    .map(mapOperator) // 新线程，由 observeOn() 指定<br />
    .observeOn(Schedulers.io())<br />
    .map(mapOperator2) // IO 线程，由 observeOn() 指定<br />
    .observeOn(AndroidSchedulers.mainThread)<br />
    .subscribe(subscriber);  // Android 主线程，由 observeOn() 指定</pre>
</div>
<p>如上，通过&nbsp;<code>observeOn()</code>&nbsp;的多次调用，程序实现了线程的多次切换。</p>
<p>不过，不同于&nbsp;<code>observeOn()</code>&nbsp;，&nbsp;<code>subscribeOn()</code>&nbsp;的位置放在哪里都可以，但它是只能调用一次的。</p>
<p>又有好事的（其实还是当初的我）问了：如果我非要调用多次&nbsp;<code>subscribeOn()</code>&nbsp;呢？会有什么效果？</p>
<p>这个问题先放着，我们还是从 RxJava 线程控制的原理说起吧。</p>
<h5>2) Scheduler 的原理（二）</h5>
<p>其实，&nbsp;<code>subscribeOn()</code>&nbsp;和&nbsp;<code>observeOn()</code>&nbsp;的内部实现，也是用的&nbsp;<code>lift()</code>。具体看图（不同颜色的箭头表示不同的线程）：</p>
<p><code>subscribeOn()</code>&nbsp;原理图：</p>
<p><img referrerpolicy="no-referrer"src="http://ww4.sinaimg.cn/mw1024/52eb2279jw1f2rxcynbsuj20ha0d7wg2.jpg" data-src="http://ww4.sinaimg.cn/mw1024/52eb2279jw1f2rxcynbsuj20ha0d7wg2.jpg" /></p>
<p><code>observeOn()</code>&nbsp;原理图：</p>
<p><img referrerpolicy="no-referrer"src="http://ww4.sinaimg.cn/mw1024/52eb2279jw1f2rxd05lttj20hj0cyabl.jpg" data-src="http://ww4.sinaimg.cn/mw1024/52eb2279jw1f2rxd05lttj20hj0cyabl.jpg" /></p>
<p>从图中可以看出，<code>subscribeOn()</code>&nbsp;和&nbsp;<code>observeOn()</code>&nbsp;都做了线程切换的工作（图中的 "schedule..." 部位）。不同的是，&nbsp;<code>subscribeOn()</code>&nbsp;的线程切换发生在&nbsp;<code>OnSubscribe</code>&nbsp;中，即在它通知上一级&nbsp;<code>OnSubscribe</code>&nbsp;时，这时事件还没有开始发送，因此&nbsp;<code>subscribeOn()</code>&nbsp;的线程控制可以从事件发出的开端就造成影响；而&nbsp;<code>observeOn()</code>&nbsp;的线程切换则发生在它内建的&nbsp;<code>Subscriber</code>&nbsp;中，即发生在它即将给下一级&nbsp;<code>Subscriber</code>&nbsp;发送事件时，因此&nbsp;<code>observeOn()</code>&nbsp;控制的是它后面的线程。</p>
<p>最后，我用一张图来解释当多个&nbsp;<code>subscribeOn()</code>&nbsp;和&nbsp;<code>observeOn()</code>&nbsp;混合使用时，线程调度是怎么发生的（由于图中对象较多，相对于上面的图对结构做了一些简化调整）：</p>
<p><img referrerpolicy="no-referrer"src="http://ww1.sinaimg.cn/mw1024/52eb2279jw1f2rxd1vl7xj20hd0hzq6e.jpg" data-src="http://ww1.sinaimg.cn/mw1024/52eb2279jw1f2rxd1vl7xj20hd0hzq6e.jpg" /></p>
<p>图中共有 5 处含有对事件的操作。由图中可以看出，①和②两处受第一个&nbsp;<code>subscribeOn()</code>&nbsp;影响，运行在红色线程；③和④处受第一个&nbsp;<code>observeOn()</code>&nbsp;的影响，运行在绿色线程；⑤处受第二个&nbsp;<code>onserveOn()</code>&nbsp;影响，运行在紫色线程；而第二个&nbsp;<code>subscribeOn()</code>&nbsp;，由于在通知过程中线程就被第一个&nbsp;<code>subscribeOn()</code>&nbsp;截断，因此对整个流程并没有任何影响。这里也就回答了前面的问题：当使用了多个&nbsp;<code>subscribeOn()</code>&nbsp;的时候，只有第一个&nbsp;<code>subscribeOn()</code>&nbsp;起作用。</p>
<h5>3) 延伸：doOnSubscribe()</h5>
<p>然而，虽然超过一个的&nbsp;<code>subscribeOn()</code>&nbsp;对事件处理的流程没有影响，但在流程之前却是可以利用的。</p>
<p>在前面讲&nbsp;<code>Subscriber</code>&nbsp;的时候，提到过&nbsp;<code>Subscriber</code>&nbsp;的&nbsp;<code>onStart()</code>&nbsp;可以用作流程开始前的初始化。然而&nbsp;<code>onStart()</code>&nbsp;由于在&nbsp;<code>subscribe()</code>&nbsp;发生时就被调用了，因此不能指定线程，而是只能执行在&nbsp;<code>subscribe()</code>&nbsp;被调用时的线程。这就导致如果&nbsp;<code>onStart()</code>&nbsp;中含有对线程有要求的代码（例如在界面上显示一个 ProgressBar，这必须在主线程执行），将会有线程非法的风险，因为有时你无法预测&nbsp;<code>subscribe()</code>&nbsp;将会在什么线程执行。</p>
<p>而与&nbsp;<code>Subscriber.onStart()</code>&nbsp;相对应的，有一个方法&nbsp;<code>Observable.doOnSubscribe()</code>&nbsp;。它和&nbsp;<code>Subscriber.onStart()</code>&nbsp;同样是在&nbsp;<code>subscribe()</code>&nbsp;调用后而且在事件发送前执行，但区别在于它可以指定线程。默认情况下，&nbsp;<code>doOnSubscribe()</code>&nbsp;执行在&nbsp;<code>subscribe()</code>&nbsp;发生的线程；而如果在&nbsp;<code>doOnSubscribe()</code>&nbsp;之后有&nbsp;<code>subscribeOn()</code>&nbsp;的话，它将执行在离它最近的&nbsp;<code>subscribeOn()</code>&nbsp;所指定的线程。</p>
<p>示例代码：</p>
<div>
<pre class="prettyprint linenums">Observable.create(onSubscribe)<br />
    .subscribeOn(Schedulers.io())<br />
    .doOnSubscribe(new Action0() {<br />
        @Override<br />
        public void call() {<br />
            progressBar.setVisibility(View.VISIBLE); // 需要在主线程执行<br />
        }<br />
    })<br />
    .subscribeOn(AndroidSchedulers.mainThread()) // 指定主线程<br />
    .observeOn(AndroidSchedulers.mainThread())<br />
    .subscribe(subscriber);</pre>
</div>
<p>如上，在&nbsp;<code>doOnSubscribe()</code>的后面跟一个&nbsp;<code>subscribeOn()</code>&nbsp;，就能指定准备工作的线程了。</p>
<h3>RxJava 的适用场景和使用方式</h3>
<h4>1. 与 Retrofit 的结合</h4>
<blockquote><p>Retrofit 是 Square 的一个著名的网络请求库。没有用过 Retrofit 的可以选择跳过这一小节也没关系，我举的每种场景都只是个例子，而且例子之间并无前后关联，只是个抛砖引玉的作用，所以你跳过这里看别的场景也可以的。</p></blockquote>
<p>Retrofit 除了提供了传统的&nbsp;<code>Callback</code>&nbsp;形式的 API，还有 RxJava 版本的&nbsp;<code>Observable</code>&nbsp;形式 API。下面我用对比的方式来介绍 Retrofit 的 RxJava 版 API 和传统版本的区别。</p>
<p>以获取一个&nbsp;<code>User</code>&nbsp;对象的接口作为例子。使用Retrofit 的传统 API，你可以用这样的方式来定义请求：</p>
<div>
<pre class="prettyprint linenums">@GET("/user")<br />
public void getUser(@Query("userId") String userId, Callback&lt;User&gt; callback);</pre>
</div>
<p>在程序的构建过程中， Retrofit 会把自动把方法实现并生成代码，然后开发者就可以利用下面的方法来获取特定用户并处理响应：</p>
<div>
<pre class="prettyprint linenums">getUser(userId, new Callback&lt;User&gt;() {<br />
    @Override<br />
    public void success(User user) {<br />
        userView.setUser(user);<br />
    }

    @Override<br />
    public void failure(RetrofitError error) {<br />
        // Error handling<br />
        ...<br />
    }<br />
};</pre>
</div>
<p>而使用 RxJava 形式的 API，定义同样的请求是这样的：</p>
<div>
<pre class="prettyprint linenums">@GET("/user")<br />
public Observable&lt;User&gt; getUser(@Query("userId") String userId);</pre>
</div>
<p>使用的时候是这样的：</p>
<div>
<pre class="prettyprint linenums">getUser(userId)<br />
    .observeOn(AndroidSchedulers.mainThread())<br />
    .subscribe(new Observer&lt;User&gt;() {<br />
        @Override<br />
        public void onNext(User user) {<br />
            userView.setUser(user);<br />
        }

        @Override<br />
        public void onCompleted() {<br />
        }

        @Override<br />
        public void onError(Throwable error) {<br />
            // Error handling<br />
            ...<br />
        }<br />
    });</pre>
</div>
<p>看到区别了吗？</p>
<p>当 RxJava 形式的时候，Retrofit 把请求封装进&nbsp;<code>Observable</code>&nbsp;，在请求结束后调用&nbsp;<code>onNext()</code>&nbsp;或在请求失败后调用&nbsp;<code>onError()</code>。</p>
<p>对比来看，&nbsp;<code>Callback</code>&nbsp;形式和&nbsp;<code>Observable</code>&nbsp;形式长得不太一样，但本质都差不多，而且在细节上&nbsp;<code>Observable</code>形式似乎还比&nbsp;<code>Callback</code>&nbsp;形式要差点。那 Retrofit 为什么还要提供 RxJava 的支持呢？</p>
<p>因为它好用啊！从这个例子看不出来是因为这只是最简单的情况。而一旦情景复杂起来，&nbsp;<code>Callback</code>&nbsp;形式马上就会开始让人头疼。比如：</p>
<p>假设这么一种情况：你的程序取到的&nbsp;<code>User</code>&nbsp;并不应该直接显示，而是需要先与数据库中的数据进行比对和修正后再显示。使用&nbsp;<code>Callback</code>&nbsp;方式大概可以这么写：</p>
<div>
<pre class="prettyprint linenums">getUser(userId, new Callback&lt;User&gt;() {<br />
    @Override<br />
    public void success(User user) {<br />
        processUser(user); // 尝试修正 User 数据<br />
        userView.setUser(user);<br />
    }

    @Override<br />
    public void failure(RetrofitError error) {<br />
        // Error handling<br />
        ...<br />
    }<br />
};</pre>
</div>
<p>有问题吗？</p>
<p>很简便，但不要这样做。为什么？因为这样做会影响性能。数据库的操作很重，一次读写操作花费 10~20ms 是很常见的，这样的耗时很容易造成界面的卡顿。所以通常情况下，如果可以的话一定要避免在主线程中处理数据库。所以为了提升性能，这段代码可以优化一下：</p>
<div>
<pre class="prettyprint linenums">getUser(userId, new Callback&lt;User&gt;() {<br />
    @Override<br />
    public void success(User user) {<br />
        new Thread() {<br />
            @Override<br />
            public void run() {<br />
                processUser(user); // 尝试修正 User 数据<br />
                runOnUiThread(new Runnable() { // 切回 UI 线程<br />
                    @Override<br />
                    public void run() {<br />
                        userView.setUser(user);<br />
                    }<br />
                });<br />
            }).start();<br />
    }

    @Override<br />
    public void failure(RetrofitError error) {<br />
        // Error handling<br />
        ...<br />
    }<br />
};</pre>
</div>
<p>性能问题解决，但&hellip;&hellip;这代码实在是太乱了，迷之缩进啊！杂乱的代码往往不仅仅是美观问题，因为代码越乱往往就越难读懂，而如果项目中充斥着杂乱的代码，无疑会降低代码的可读性，造成团队开发效率的降低和出错率的升高。</p>
<p>这时候，如果用 RxJava 的形式，就好办多了。 RxJava 形式的代码是这样的：</p>
<div>
<pre class="prettyprint linenums">getUser(userId)<br />
    .doOnNext(new Action1&lt;User&gt;() {<br />
        @Override<br />
        public void call(User user) {<br />
            processUser(user);<br />
        })<br />
    .observeOn(AndroidSchedulers.mainThread())<br />
    .subscribe(new Observer&lt;User&gt;() {<br />
        @Override<br />
        public void onNext(User user) {<br />
            userView.setUser(user);<br />
        }

        @Override<br />
        public void onCompleted() {<br />
        }

        @Override<br />
        public void onError(Throwable error) {<br />
            // Error handling<br />
            ...<br />
        }<br />
    });</pre>
</div>
<p>后台代码和前台代码全都写在一条链中，明显清晰了很多。</p>
<p>再举一个例子：假设&nbsp;<code>/user</code>&nbsp;接口并不能直接访问，而需要填入一个在线获取的&nbsp;<code>token</code>&nbsp;，代码应该怎么写？</p>
<p><code>Callback</code>&nbsp;方式，可以使用嵌套的&nbsp;<code>Callback</code>：</p>
<div>
<pre class="prettyprint linenums">@GET("/token")<br />
public void getToken(Callback&lt;String&gt; callback);

@GET("/user")<br />
public void getUser(@Query("token") String token, @Query("userId") String userId, Callback&lt;User&gt; callback);

...

getToken(new Callback&lt;String&gt;() {<br />
    @Override<br />
    public void success(String token) {<br />
        getUser(token, userId, new Callback&lt;User&gt;() {<br />
            @Override<br />
            public void success(User user) {<br />
                userView.setUser(user);<br />
            }

            @Override<br />
            public void failure(RetrofitError error) {<br />
                // Error handling<br />
                ...<br />
            }<br />
        };<br />
    }

    @Override<br />
    public void failure(RetrofitError error) {<br />
        // Error handling<br />
        ...<br />
    }<br />
});</pre>
</div>
<p>倒是没有什么性能问题，可是迷之缩进毁一生，你懂我也懂，做过大项目的人应该更懂。</p>
<p>而使用 RxJava 的话，代码是这样的：</p>
<div>
<pre class="prettyprint linenums">@GET("/token")<br />
public Observable&lt;String&gt; getToken();

@GET("/user")<br />
public Observable&lt;User&gt; getUser(@Query("token") String token, @Query("userId") String userId);

...

getToken()<br />
    .flatMap(new Func1&lt;String, Observable&lt;User&gt;&gt;() {<br />
        @Override<br />
        public Observable&lt;User&gt; onNext(String token) {<br />
            return getUser(token, userId);<br />
        })<br />
    .observeOn(AndroidSchedulers.mainThread())<br />
    .subscribe(new Observer&lt;User&gt;() {<br />
        @Override<br />
        public void onNext(User user) {<br />
            userView.setUser(user);<br />
        }

        @Override<br />
        public void onCompleted() {<br />
        }

        @Override<br />
        public void onError(Throwable error) {<br />
            // Error handling<br />
            ...<br />
        }<br />
    });</pre>
</div>
<p>用一个&nbsp;<code>flatMap()</code>&nbsp;就搞定了逻辑，依然是一条链。看着就很爽，是吧？</p>
<p>2016/03/31 更新，加上我写的一个 Sample 项目：&nbsp;<br /><a href="https://github.com/rengwuxian/RxJavaSamples" rel="external nofollow noreferrer">rengwuxian RxJava Samples</a></p>
<p>好，Retrofit 部分就到这里。</p>
<h4>2. RxBinding</h4>
<p><a href="https://github.com/JakeWharton/RxBinding" rel="external nofollow noreferrer">RxBinding</a>&nbsp;是 Jake Wharton 的一个开源库，它提供了一套在 Android 平台上的基于 RxJava 的 Binding API。所谓 Binding，就是类似设置&nbsp;<code>OnClickListener</code>&nbsp;、设置&nbsp;<code>TextWatcher</code>&nbsp;这样的注册绑定对象的 API。</p>
<p>举个设置点击监听的例子。使用&nbsp;<code>RxBinding</code>&nbsp;，可以把事件监听用这样的方法来设置：</p>
<div>
<pre class="prettyprint linenums">Button button = ...;<br />
RxView.clickEvents(button) // 以 Observable 形式来反馈点击事件<br />
    .subscribe(new Action1&lt;ViewClickEvent&gt;() {<br />
        @Override<br />
        public void call(ViewClickEvent event) {<br />
            // Click handling<br />
        }<br />
    });</pre>
</div>
<p>看起来除了形式变了没什么区别，实质上也是这样。甚至如果你看一下它的源码，你会发现它连实现都没什么惊喜：它的内部是直接用一个包裹着的&nbsp;<code>setOnClickListener()</code>&nbsp;来实现的。然而，仅仅这一个形式的改变，却恰好就是&nbsp;<code>RxBinding</code>&nbsp;的目的：扩展性。通过&nbsp;<code>RxBinding</code>&nbsp;把点击监听转换成&nbsp;<code>Observable</code>&nbsp;之后，就有了对它进行扩展的可能。扩展的方式有很多，根据需求而定。一个例子是前面提到过的&nbsp;<code>throttleFirst()</code>&nbsp;，用于去抖动，也就是消除手抖导致的快速连环点击：</p>
<div>
<pre class="prettyprint linenums">RxView.clickEvents(button)<br />
    .throttleFirst(500, TimeUnit.MILLISECONDS)<br />
    .subscribe(clickAction);</pre>
</div>
<p>如果想对&nbsp;<code>RxBinding</code>&nbsp;有更多了解，可以去它的&nbsp;<a href="https://github.com/JakeWharton/RxBinding" rel="external nofollow noreferrer">GitHub 项目</a>&nbsp;下面看看。</p>
<h4>3. 各种异步操作</h4>
<p>前面举的&nbsp;<code>Retrofit</code>&nbsp;和&nbsp;<code>RxBinding</code>&nbsp;的例子，是两个可以提供现成的&nbsp;<code>Observable</code>&nbsp;的库。而如果你有某些异步操作无法用这些库来自动生成&nbsp;<code>Observable</code>，也完全可以自己写。例如数据库的读写、大图片的载入、文件压缩/解压等各种需要放在后台工作的耗时操作，都可以用 RxJava 来实现，有了之前几章的例子，这里应该不用再举例了。</p>
<h4>4. RxBus</h4>
<p>RxBus 名字看起来像一个库，但它并不是一个库，而是一种模式，它的思想是使用 RxJava 来实现了 EventBus ，而让你不再需要使用&nbsp;<code>Otto</code>&nbsp;或者 GreenRobot 的&nbsp;<code>EventBus</code>。至于什么是 RxBus，可以看<a href="http://nerds.weddingpartyapp.com/tech/2014/12/24/implementing-an-event-bus-with-rxjava-rxbus/" rel="external nofollow noreferrer">这篇文章</a>。顺便说一句，Flipboard 已经用 RxBus 替换掉了&nbsp;<code>Otto</code>&nbsp;，目前为止没有不良反应。</p>
<h3>最后</h3>
<p>对于 Android 开发者来说， RxJava 是一个很难上手的库，因为它对于 Android 开发者来说有太多陌生的概念了。可是它真的很牛逼。因此，我写了这篇《给 Android 开发者的 RxJava 详解》，希望能给始终搞不明白什么是 RxJava 的人一些入门的指引，或者能让正在使用 RxJava 但仍然心存疑惑的人看到一些更深入的解析。无论如何，只要能给各位同为 Android 工程师的你们提供一些帮助，这篇文章的目的就达到了。</p>
<p>再次感谢对这篇文章的产出提供支持的各位：&nbsp;<br />技术支持：<a href="http://weibo.com/wowwing" rel="external nofollow noreferrer">流火枫林</a>&nbsp;<br />内测读者：<a href="http://weibo.com/daimajia" rel="external nofollow noreferrer">代码家</a>、<a href="http://weibo.com/u/3224930551" rel="external nofollow noreferrer">鲍永章</a>、<a href="https://github.com/drakeet" rel="external nofollow noreferrer">drakeet</a>、<a href="https://github.com/androidmalin" rel="external nofollow noreferrer">马琳</a>、<a href="http://weibo.com/kevingracie" rel="external nofollow noreferrer">有时放纵</a>、<a href="http://weibo.com/u/2559577095" rel="external nofollow noreferrer">程序亦非猿</a>、<a href="http://weibo.com/brucefromsdu" rel="external nofollow noreferrer">大头鬼</a>、<a href="http://weibo.com/u/2662418685" rel="external nofollow noreferrer">XZoomEye</a>、<a href="http://weibo.com/shadev" rel="external nofollow noreferrer">席德雨</a>、<a href="http://weibo.com/tcahead" rel="external nofollow noreferrer">TCahead</a>、<a href="http://weibo.com/u/1963663403" rel="external nofollow noreferrer">Tiiime</a>、<a href="http://weibo.com/208087666" rel="external nofollow noreferrer">Ailurus</a>、<a href="http://weibo.com/seniorszhai" rel="external nofollow noreferrer">宅学长</a>、<a href="http://naotou.github.io/" rel="external nofollow noreferrer">妖孽</a>、<a href="http://weibo.com/u/3214362483" rel="external nofollow noreferrer">大大大大大臣哥</a>、<a href="https://github.com/rizhilee" rel="external nofollow noreferrer">NicodeLee</a>&nbsp;<br />赞助方：<a href="http://jobtong.com/" rel="external nofollow noreferrer">周伯通招聘</a>&nbsp;是他们让我的文章能够以不那么丑陋的样子出现在大家面前。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mwp2oq.html">Python 基礎 - 列表的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwx2gy9.html">《JavaScript DOM编程艺术》笔记一</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1xlkz8.html">windows7系统下一些常用工具的总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/3903r2m9.html">win32手动创建windows窗口的，小记</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ed4kz9.html">sqlite 跨数据库查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oxj0x8.html">css教程如何修改留言板程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oknejp9.html">Android内存Context泄露：Handler&amp;amp&semi;内部类</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e11pnj9.html">node开发   npm install -g express-generator&commat;4</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m006xq.html">【转】angular学习笔记&lpar;十四&rpar;-&dollar;watch&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm350e9.html">【最短路】【数学】CSU 1806 Toll &lpar;2016湖南省第十二届大学生计算机程序设计竞赛&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meyolpq.html">java基本的要点</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jnjzw8.html">洛谷P1171 售货员的难题【状压DP】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgo2248.html">C&num;常用的单元测试框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2e6m2q.html">LinkedIn TAG</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25ngevq.html">luogu P1084 疫情控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj0xj49.html">Django学习手册 - 自定义simple&lowbar;tag  &sol;  filter</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwzlny8.html">AreaHttpControllerSelector 对 Web Api 实现 Area 路由控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2wpjd8.html">An &amp;&num;39&semi;&amp;&num;39&semi;all&amp;&num;39&semi;&amp;&num;39&semi; model group must appear in a particle with&period;&period;&period;问题解决记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvy122q.html">win10 教育版本变专业版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vj1p5q.html">led的驱动及测试程序</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95gdzxzq.html">php-memcache基本用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/960dl1y9.html">JQuery插件之【jqGrid】常用语法整理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdy60e9.html">gitlab备份、恢复、升级</a>
			</li>
						<li><a href="https://www.batexi.com/a/q253g7lq.html">Jenkins&plus;Jmeter持续集成笔记（一：环境准备）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4wr5x9.html">SQLAlchemy（包含有Flask-Migrate知识点）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r4wd08.html">C&num;基础加强&lpar;3&rpar;之值、引用类型及结构体</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjgxje9.html">&lbrack;js&rsqb;js的惰性声明&comma; js中声明过的变量&lpar;预解释&rpar;&comma;后在不会重新声明了</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2knpz9.html">解决&period;NET iis初次加载超级慢</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r4oz48.html">221&period; Maximal Square&lpar;动态规划&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2kpk19.html">Java IO--NIO（二）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
